class autoupdate::apt (
        Array $extra_repo = [],
        Boolean $manage_os_default_repos = true,
        Array $exclude_packages = [],
        String $provider = '/usr/bin/apt-get'
)
{
	if !($extra_repo.empty()){
                #TODO : 
                # Si il est pas vide check avec functions que chaque repo est configuré sur le node
                # Si un repo est indiqué mais pas configuré message de retour avec erreur
                #- Configurer les repo extra pour l'update et l'upgrade
                case $provider {
                        "/usr/bin/apt-get": {
                                $update_extra=[$provider,"update"]
                                $upgrade_extra=[$provider,"upgrade"]
                        }
                        default:  {
			        fail("Provider unknown")	     
                        }
                }
		if !($manage_os_default_repos) {
			fail("No repo is managed for updates")	
		}
	}

        if $manage_os_default_repos {
                case $provider {
                        "/usr/bin/apt-get": {
                                $update_base=[$provider,"--default-release","stable","update"]
                                $upgrade_base=[$provider,"--default-release","stable","upgrade"]
                        }
                        default:  {
			        fail("Provider unknown")	     
                        }
                }
        }
	if !($exclude_packages.empty()){
                $exclude_packages.each |$package| {
                        apt::hold { $package :
                                setting => 'hold',
                        }
                }
        }

	if $update_base and $upgrade_base {
        	 exec { 'apt_update':
                        command     => join($update_base," "),
                        try_sleep   => 1
                }
                exec { 'apt_upgrade':
                        command     => join($upgrade_base," "),
                        try_sleep   => 1
                }  
        }
        if $update_extra and $upgrade_extra {
                exec { 'apt_update':
                        command     => join($update_extra," "),
                        try_sleep   => 1
                }
                exec { 'apt_upgrade':
                        command     => join($upgrade_extra," "),
                        try_sleep   => 1
                }  
        }


	if !($exclude_packages.empty()){
                $exclude_packages.each |$package| {
                        apt::hold { $package :
                                setting => 'unhold',
                        }
                }
        }


}
