class autoupdate::yum (
        Array $extra_repo = [],
        Boolean $manage_os_default_repos = true,
        Array $exclude_packages = [],
        String $provider = '/usr/bin/yum'

){


	if !($extra_repo.empty()){
                #TODO : 
                # Si il est pas vide check avec functions que chaque repo est configuré sur le node
                # Si un repo est indiqué mais pas configuré message de retour avec erreur

                case $provider {
                        "/usr/bin/yum": {
                                $upgrade_extra=[$provider,"upgrade","-y","--disablerepo=*","--enablerepo=${join(extra_repo,",")}"]
                        }
                        default:  {
			        fail("Provider unknown")	     
                        }
                }

		if !($manage_os_default_repos) {
			fail("No repo is managed for updates")	
		}
	}

        if $manage_os_default_repos {
                case "${facts['os']['name']} ${facts['os']['release']['major']}" {
                        'OracleLinux 8':  {
                                $os_default_repos=join(['ol8_baseos_latest','ol8_appstream','ol8_UEKR6'],",")
                        }
                        'CentOS 7':  {
                                $os_default_repos=join(['base','updates'],",")
                        }
                        default:  {
			        fail("OS and/or release doesn't support")	
                        }
                }
                case $provider {
                        "/usr/bin/yum": {
                                $upgrade_base=[$provider,"upgrade","-y","--disablerepo=*","--enablerepo=${os_default_repos}"]
                        }
                        default:  {
			        fail("Provider unknown")	     
                        }
                }
        }


	if $upgrade_base {
                exec { "${provider} upgrade base":
                        command     => join($upgrade_base," "),
                        try_sleep   => 1,
			timeout => 0
                }
                notify { join($upgrade_base," "): }
        }
        if $upgrade_extra {
                exec { "${provider} upgrade base":
                        command     => join($upgrade_extra," "),
                        try_sleep   => 1,
			timeout => 0
                }
                notify { join($upgrade_extra," "): }

        }


}

